module Erorr
  module Middleware
    class Rack
      def initialize(app)
        @app = app
      end

      def call(env)
        begin
          response = @app.call(env)
        rescue Exception => exception
          request = ActionDispatch::Request.new env

          headers = request.headers.env.select{|k, _| k.in?(ActionDispatch::Http::Headers::CGI_VARIABLES) || k =~ /^HTTP_/}
          location = request.parameters.values_at('controller', 'action').compact.join('#')
          location = location.presence || "#{headers['REQUEST_METHOD']} #{headers['PATH_INFO']}"

          request_params = {
            params: request.parameters,
            remote_ip: request.remote_ip,
            headers: headers,
          }

          Erorr.notify exception, location: location, request: request_params

          raise
        end

        response
      ensure
        # Erorr.clear_request_data
      end
    end
  end
end
